import { Component, EventEmitter, Input, OnDestroy, OnChanges, OnInit, Output, ApplicationRef, ChangeDetectorRef } from '@angular/core';
import { JsonPipe } from '@angular/common';


@Component({
  selector: 'app-form',
  templateUrl: './form.component.html',
  styleUrls: ['./form.component.css']
})
export class FormComponent implements OnInit, OnChanges, OnDestroy {

  // 储存数据用
  saveKey = "JM_4-1";
  // 储存对象
  item;

  customTypeGroupArr = [

    {
      name: '输入框区域',
      rect: true,
      isShowPos: true,
      isCopy: true,

      select: [
        {label: '日期', value: 'date'},
        {label: '时间', value: 'time'},
        {label: '人名', value: 'name'},
        {label: '城市', value: 'city'},

        {label: '电器', value: 'device'},
        {label: '方位', value: 'side'},
        {label: '工作', value: 'work'},
        {label: '形容词', value: 'adj'},
        {label: '单词', value: 'word'},
      ],
      label: '比对',
    },
    // {
    //   name: '提交按钮',
    //   rect: true,
    //   isFixed: true
    // },
  ]


  constructor(private appRef: ApplicationRef, private changeDetectorRef: ChangeDetectorRef) {

  }

  createShell() {
    this.item.wordList.push({
      word: '',
      audio: '',
      backWord: '',
      backWordAudio: '',
    });
    this.save();
  }

  removeShell(idx) {
    this.item.wordList.splice(idx, 1);
    this.save();
  }

  ngOnInit() {

    this.item = {};

    // 获取存储的数据
    (<any>window).courseware.getData((data) => {

      if (data) {
        this.item = data;
      }

      this.init();
      this.changeDetectorRef.markForCheck();
      this.changeDetectorRef.detectChanges();
      this.refresh();

    }, this.saveKey);
  }

  ngOnChanges() {
  }

  ngOnDestroy() {
  }

  init() {

    if (!this.item.sentenceArr) {
      this.item.sentenceArr = [];
    }
    if (!this.item.templateArr) {
     this.item.templateArr = [];
    }
    
  }

  addSubTemplate() {
    this.item.templateArr.push({
    })

    this.save();
  }

  onDeleteTemplate(e, index) {
    this.item.templateArr[index] = {};
    this.item.templateArr.splice(index, 1);
    this.save();
  }

  onSaveTemplate(e, index) {

    this.item.templateArr[index] = e;
    this.save();
  }



  addBtnClick() {
    this.item.sentenceArr.push({});
    this.save();
  }

  deleteBtnClick(index) {
    this.item.sentenceArr.splice(index, 1);
    this.save();

  }

  onSaveCustomAction(e) {
    console.log('e:', e);
    this.item.customAction = e;
    this.save();
  }


  saveHotZone(group, e) {
    console.log('e: ', e);
    const {bgItem, hotZoneItemArr} = e;
  
    group.bgItem = bgItem;
    group.hotZoneItemArr = hotZoneItemArr;

    this.save();
  }


  /**
   * 储存图片数据
   * @param e
   */
  onImageUploadSuccess(e, key) {

    this.item[key] = e.url;
    this.save();
  }

  /**
   * 储存音频数据
   * @param e
   */
  onAudioUploadSuccess(e, key) {
    this.item[key] = e.url;
    this.save();
  }

  onWordAudioUploadSuccess(e, idx) {
    this.item.wordList[idx].audio = e.url;
    this.save();
  }

  onBackWordAudioUploadSuccess(e, idx) {
    this.item.wordList[idx].backWordAudio = e.url;
    this.save();
  }

  /**
   * 储存数据
   */
  save() {
    (<any>window).courseware.setData(this.item, null, this.saveKey);

    this.refresh();
    console.log('this.item = ' + JSON.stringify(this.item));
  }

  /**
   * 刷新 渲染页面
   */
  refresh() {
    setTimeout(() => {
      this.appRef.tick();
    }, 1);
  }

}